open YaccTypes;;
open N2dYacc;;
open N2dLex;;
open HeadFinder;;
open FindParent;;
open PrintDep;;
open Nivre;;
open DepToTrans;;
open TransToConfig;;


let rec printFirst sl = match sl with 
 [] -> flush stdout
|h::t -> print_string ("{word=\""^h.word^"\";cat=\""^h.cat^"\";pos="^(string_of_int h.pos)^";parent="^(string_of_int h.parent)^";mainChild=("^(string_of_int h.mainChild)^");edge=\""^h.edge^"\"};\n"); printFirst t;;

let evaluate () =
 begin
  let file = ref "" in
  Arg.parse [ ("-file",Arg.Set_string file,"Input file in proper format (see README for specs)");]
    (function s -> print_string ("didn't understand "^s^"\n"))
    "Invoke the Negra to Configuration Converter";

  if !file = "" then failwith "input file required";
  let sentenceList =
  begin
    YaccTypes.linenum := 1; 
    try N2dYacc.sentenceList N2dLex.token (Lexing.from_channel (open_in !file))
    with (Parsing.Parse_error ) ->
      (print_string ("Syntax error in line "^(string_of_int !YaccTypes.linenum)^"\n");
      [])
  end in
  let count =(print_string ("\nFinished reading "^(!file)^".\nConverting "^(string_of_int (List.length sentenceList))^" sentences to dependencies...\n"));(flush stdout); (List.length sentenceList) in
  let depList = (iterSentences sentenceList []) in

  let depPrint= (print_string ("Finished converting to dependencies...outputting dependencies.\n"));(flush stdout);(runPrint depList 0) in 
  let transitionHash = (print_string ("Finished outputting dependencies...converting to transitions.\n"));(flush stdout);(runTrans depList 0 (Hashtbl.create 1000000)) in
  let configHash = (print_string ("Finished converting to transitions...converting to configurations.\n"));(flush stdout);runT2C transitionHash sentenceList 0 (Hashtbl.create 1000000) in    
  let runIt = (print_string ("\nFinished converting to configurations...outputting configurations.\n"));(flush stdout);(printAll configHash 0 ((Hashtbl.length configHash)-1)); true in
  if (runIt == true) then (print_string ("Finished printing configurations from  "^(!file)^", "^(string_of_int count)^" sentences converted.\n")) else (print_string ("Something didn't work\n"));
    
end;;

evaluate();;
