open YaccTypes;;
open Nivre;;

let errorOut = open_out ("../Output/errors.txt");;
(*DATA LOADER: Takes in a file in ptb format, outputs a list of node sentences *)


(*TRANSITION MAKER: NOTE: This only makes LEFT, RIGHT, and SHIFT transitions.  REDUCE can not be added until we see actual Configs (next step)*)
type operation = Left | Right | Shift | Reduce;;
type transition = {op: operation; fromWord: node; toWord: node};;

let setArrayLeft tArray op pos = 
  let getList = Array.get tArray pos in 
     ((Array.set tArray pos (getList@[op]));tArray);;
	
let setArray tArray op pos= 
  let getList = Array.get tArray pos in 
     ((Array.set tArray pos (op::getList));tArray);;

let rec goThroughSentence fullList sList tArray = match sList with
    [] -> (Array.map (List.rev) tArray)
  |h::t -> if (h.parent == (-1)) 
    then (goThroughSentence fullList t 
	     (setArray 
		 tArray 
		 {op=Right; fromWord={word="ROOT"; cat="ROOT"; pos=(-1); parent=(-3);mainChild=(-1); edge=""}; toWord=h} 
		 h.pos))
    else 
	try (if (h.parent < h.pos)
	then (goThroughSentence fullList t
		 (setArray 
		     tArray 
		     {op=Right; fromWord=(List.nth fullList h.parent); toWord=h} 
		     h.pos))
        else (goThroughSentence fullList t 
		 (setArray 
		     (setArrayLeft tArray {op=Left;fromWord=(List.nth fullList h.parent); toWord=h} h.parent) 
		     {op=Shift; fromWord=h; toWord=h} 
		     h.pos)))
  with Invalid_argument "List.nth" -> (output_string errorOut (h.word^"\t")); (flush errorOut); (goThroughSentence fullList t tArray) ;;

let rec runTrans sentenceList i tHash = match sentenceList with
    [] -> tHash
  |h::t  -> (Hashtbl.add tHash i (List.flatten (Array.to_list (goThroughSentence h h (Array.make (List.length h) [])))));
             (runTrans t (i+1) tHash);;

(*let transitionHash = runTrans sentenceList 0 (Hashtbl.create 130000);;*)


