(*Based on the rules originally developed by David Magerman (1995)
and the code by Amit Dubey*)

type direction = Left | Right;;
type headRule = {name:string; dir: direction; heads: string list};;

let headRules =
[{name="AA"; dir=Right; heads=[ "ADJA"; "ADJD"; "PIS" ]};
{name="AP"; dir=Right; heads=[ "ADJA"; "ADJD"; "CAP"; "CARD"; "PIAT"; "PIDAT"; "PIS" ]};
{name="AVP"; dir=Right; heads=[ "ADV"; "AVP"; "CAVP"; "ADJA"; "ADJD" ]};
{name="CAC"; dir=Left; heads=[ "APPR"; "APZR"; "APPO" ]};
{name="CAP"; dir=Left; heads=[ "ADJA"; "ADJD"; "CARD" ]};
{name="CAVP"; dir=Left; heads=[ "AVP"; "ADV"; "CAVP" ]};
{name="CCP"; dir=Left; heads=[]};
{name="CNP"; dir=Left; heads=[ "NP"; "NN"; "NE"; "MPN"; "CNP"; "CARD"; "PRF"; "PIS"; "PPER"; "FM" ] };
{name="CPP"; dir=Left; heads=[ "PP"; "CPP" ]};
{name="CVP"; dir=Left; heads=[ "VP"; "VZ"; "CVP"; "VVINF"; "VVPP"; "VVIZU" ] };
{name="CVZ"; dir=Left; heads=[ "VZ"; "CV" ]};
{name="CS"; dir=Left; heads=[ "S"; "CS"; "CO"; "D" ]};
{name="CO"; dir=Left; heads=[ "S"; "VVINF"; "VVPP"; "VP"; "NP"; "PP"; "AP"; "ADJA"; "ADJD"; "PI" ]};
{name="CH"; dir=Left; heads=[]};
{name="DL"; dir=Right; heads=[ "S"; "C" ]};
{name="ISU"; dir=Right; heads=[]};
{name="TOP"; dir=Left; heads=[ "S"; "NP"; "MPN"; "NM"; "CS"; "CNP"; "AP"; "CAP"; "CO"; "DL" ]};
{name="MPN"; dir=Right; heads=[ "NE"; "FM"; "CARD" ]};
{name="MTA"; dir=Right; heads=[ "ADJA"; "NE"; "TRUNC" ]};
{name="NM"; dir=Right; heads=[ "NN"; "PIAT"; "CARD"; "ORD"; "N" ]};
{name="NP"; dir=Right; heads=[ "NN"; "NE"; "NM"; "MPN"; "NP"; "CNP"; "PRELS"; "PWAT"; "PWS";
				    "PDS"; "PDAT"; "PIS"; "PIAT"; "PIDAT"; "PPER"; "PPOSS";
				    "PPOSAT"; "PRELAT"; "PRF"; "PWAV"; "ADJA"; "ADJD"; "PP"; "" ] };
{name="PP"; dir=Left; heads=[ "APPR"; "APPRART"; "APPO"; "APZR"; "CA" ]};
{name="QL"; dir=Right; heads=[]};
{name="S"; dir=Right; heads=	[ "VVFIN"; "VMFIN"; "VAFIN"; "VVIMP"; "VAIMP"; "VMPP"; "VVPP";
								  "VP"; "CVP"; "S"; "CS"; "VVINF"; "VAIMP"; "NP"; "PP" ]};
{name="VP"; dir=Right; heads=[ "VVPP"; "VVINF"; "VAINF"; "VMINF"; "VVIZU"; "VAPP"; "VZ";
							    "CVZ"; "VP"; "CVP"; "AVP"; "AP" ]};
{name="VZ"; dir=Right; heads=[ "VVINF"; "VAINF"; "VMINF"; "ADJA"; "PPOSAT" ]}]
