{
open N2dYacc;;
open YaccTypes;;
}

rule token = parse
  ['0'-'9']+   {INT (int_of_string (Lexing.lexeme lexbuf))}
  |(['a'-'z' 'A'-'Z' ',' '.' ';' ':' '?' '!' '\'' '-' '%' '@' '/' '(' ')' '$' '0'-'9' '^' '*' '`' '&' '#' '_' '+' '=' '"' '<' '>']+)      {STRING (Lexing.lexeme lexbuf)}
  |("%%" [^ '\n']+)  {COMMENT}
  |("#BOS" [^ '\n']+)      {BOS}
  |("#EOS" [^ '\n']+)    {EOS}
  |"#"['0'-'9']+       {NODE (Lexing.lexeme lexbuf)}
  |['\t']+   {TABS}
  |['\t']    {TAB}
  |[^ '\n']*eof  {EOF}
  |[^ '\n']    {token lexbuf}
  |[' ']+       {token lexbuf}
  |['\n']     {linenum := !linenum + 1;EOL} 
  |eof       {EOF}




