%{
(*Header*)
open YaccTypes;;

let parse_error s =
    print_endline  "Parse error";
    print_endline s;
    flush stdout;;

%}

/* token declarations*/

%token <string> STRING
%token <int> INT
%token TAB
%token TABS
%token EOF EOL
%token COMMENT
%token BOS
%token EOS
%token <string> NODE
%type <YaccTypes.node list list> sentenceList
%start sentenceList

%%
sentenceList: 
  BOS EOL wl EOS EOL sentenceList {(makeSentence (List.rev $3)) :: $6}
| BOS EOL wl EOS EOL {[(makeSentence (List.rev $3))]}
| EOF {[makeSentence []]}
;


wl:
  STRING TABS STRING TABS STRING TABS STRING sti  EOL wl {(makeNode $1 $5 $8) :: $10}
| STRING TABS INT TABS STRING TABS STRING sti EOL wl {(makeNode $1 $5 $8) :: $10}
| INT TABS INT TABS STRING TABS STRING sti EOL wl {(makeNode (string_of_int $1) $5 $8) :: $10}
| INT TABS STRING TABS STRING TABS STRING sti EOL wl {(makeNode (string_of_int $1) $5 $8) :: $10}
| NODE TABS STRING TABS STRING TABS STRING sti EOL wl {(makeNode $1 $5 $8) :: $10}
| STRING TABS STRING TABS STRING TABS STRING sti EOL {[makeNode $1 $5 $8]}
| INT TABS INT TABS STRING TABS STRING sti EOL {[makeNode (string_of_int $1) $5 $8]}
| NODE TABS STRING TABS STRING TABS STRING sti EOL {[makeNode $1 $5 $8]}
;

sti:
  TABS STRING TABS INT sti {($2, $4)::$5}
| TABS STRING TABS INT TABS COMMENT sti {($2, $4) :: $7}
| TABS STRING TABS INT {[$2,$4]}
| TABS STRING TABS INT TABS COMMENT {[$2,$4]}


%%









