open YaccTypes;;

(*The actual Nivre implementation*)
type config = {stack: (node list); tau: (node list); h: int array; d: string array; soFar: (node list)};;

(*NIVRE ARCS*)
let shift configuration = match configuration with 
    {stack=s; tau=hTau::tTau;h= h;d= d; soFar=sf} -> {stack=hTau::s;tau=tTau; h=(Array.copy h); d=(Array.copy d); soFar=sf@[hTau]}
  |_ -> configuration;;

let rightArc configuration i =  match configuration with
	{stack=s; tau=th::tt; h=h; d=d; soFar=sf} -> 
	  let newH = (Array.copy h) in
	  let newD = (Array.copy d) in 
	    (match i with
	    -1 -> {stack=(th::s); tau=tt; h=((Array.set newH th.pos (-1)); newH); d=((Array.set newD th.pos "right"); newD);soFar=sf}
            |_ ->  {stack=(th::s); tau=tt; h=((Array.set newH th.pos i); newH); d=((Array.set newD th.pos "right"); newD); soFar=sf})
	|_ -> configuration;;
    

let leftArc configuration i = match configuration with
    {stack=sh::st; tau=th::tt; h=h; d=d; soFar=sf} -> 
      let newH = (Array.copy h) in
      let newD = (Array.copy d) in 
	(match th.pos with
	-1 -> {stack=st; tau=th::tt; h=((Array.set newH i (-1));newH); d=((Array.set newD i "left");newD); soFar=sf}
      |_ -> {stack=st; tau=th::tt; h=((Array.set newH i th.pos);newH); d=((Array.set newD i "left");newD); soFar=sf})
    |_ -> configuration;;
	      

let reduce configuration = match configuration with 
    {stack=sh::st; tau=t; h=h; d=d; soFar=sf} -> {stack=st; tau=t; h=(Array.copy h); d=(Array.copy d); soFar=sf}
  |_ -> (configuration);;

